!include MUI2.nsh

!define SNAME "RadAsm Setup Helper"

CRCCheck off
AutoCloseWindow True
;SilentInstall silent
WindowIcon off
XPSTYLE on 
SetCompressor /SOLID lzma

Name "${SNAME}"
Caption "${SNAME}"
OutFile "${SNAME}.exe"

!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_INSTFILES

BrandingText "Associate file to Radasm"

VIProductVersion "1.0.0.0"
VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductName" "RadAsm Setup Helper"
VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalCopyright" "? Copyright 2011"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileDescription" "Packed by cntrump"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileVersion" "1.0.0.0"

Section ".a51"
	WriteRegStr HKCR ".a51" "" "Radasm.a51.3" 
	WriteRegStr HKCR "Radasm.a51.3\DefaultIcon" "" "$\"$EXEDIR\res.dll$\",0"
	WriteRegStr HKCR "Radasm.a51.3\shell\Open\Command" "" "$\"$EXEDIR\radasm.exe$\" $\"%1$\""
SectionEnd

Section ".asm"
	WriteRegStr HKCR ".asm" "" "Radasm.asm.3" 
	WriteRegStr HKCR "Radasm.asm.3\DefaultIcon" "" "$\"$EXEDIR\res.dll$\",1"
	WriteRegStr HKCR "Radasm.asm.3\shell\Open\Command" "" "$\"$EXEDIR\radasm.exe$\" $\"%1$\""
SectionEnd

Section ".bas"
	WriteRegStr HKCR ".bas" "" "Radasm.bas.3" 
	WriteRegStr HKCR "Radasm.bas.3\DefaultIcon" "" "$\"$EXEDIR\res.dll$\",2"
	WriteRegStr HKCR "Radasm.bas.3\shell\Open\Command" "" "$\"$EXEDIR\radasm.exe$\" $\"%1$\""
SectionEnd

Section ".bi"
	WriteRegStr HKCR ".bi" "" "Radasm.bi.3" 
	WriteRegStr HKCR "Radasm.bi.3\DefaultIcon" "" "$\"$EXEDIR\res.dll$\",3"
	WriteRegStr HKCR "Radasm.bi.3\shell\Open\Command" "" "$\"$EXEDIR\radasm.exe$\" $\"%1$\""
SectionEnd

Section ".c"
	WriteRegStr HKCR ".c" "" "Radasm.c.3" 
	WriteRegStr HKCR "Radasm.cpp.3\DefaultIcon" "" "$\"$EXEDIR\res.dll$\",4"
	WriteRegStr HKCR "Radasm.cpp.3\shell\Open\Command" "" "$\"$EXEDIR\radasm.exe$\" $\"%1$\""
SectionEnd

Section ".cpp"
	WriteRegStr HKCR ".cpp" "" "Radasm.cpp.3" 
	WriteRegStr HKCR "Radasm.cpp.3\DefaultIcon" "" "$\"$EXEDIR\res.dll$\",5"
	WriteRegStr HKCR "Radasm.cpp.3\shell\Open\Command" "" "$\"$EXEDIR\radasm.exe$\" $\"%1$\""
SectionEnd

Section ".def"
	WriteRegStr HKCR ".def" "" "Radasm.def.3"
	WriteRegStr HKCR "Radasm.def.3\DefaultIcon" "" "$\"$EXEDIR\res.dll$\",6"
	WriteRegStr HKCR "Radasm.def.3\shell\Open\Command" "" "$\"$EXEDIR\radasm.exe$\" $\"%1$\""
SectionEnd

Section ".h"
	WriteRegStr HKCR ".h" "" "Radasm.h.3" 
	WriteRegStr HKCR "Radasm.h.3\DefaultIcon" "" "$\"$EXEDIR\res.dll$\",7"
	WriteRegStr HKCR "Radasm.h.3\shell\Open\Command" "" "$\"$EXEDIR\radasm.exe$\" $\"%1$\""
SectionEnd

Section ".inc"
	WriteRegStr HKCR ".inc" "" "Radasm.inc.3"
	WriteRegStr HKCR "Radasm.inc.3\DefaultIcon" "" "$\"$EXEDIR\res.dll$\",8"
	WriteRegStr HKCR "Radasm.inc.3\shell\Open\Command" "" "$\"$EXEDIR\radasm.exe$\" $\"%1$\""
SectionEnd

Section ".mcu"
	WriteRegStr HKCR ".mcu" "" "Radasm.mcu.3" 
	WriteRegStr HKCR "Radasm.mcu.3\DefaultIcon" "" "$\"$EXEDIR\res.dll$\",9"
	WriteRegStr HKCR "Radasm.mcu.3\shell\Open\Command" "" "$\"$EXEDIR\radasm.exe$\" $\"%1$\""
SectionEnd

Section ".pas"
	WriteRegStr HKCR ".pas" "" "Radasm.pas.3" 
	WriteRegStr HKCR "Radasm.pas.3\DefaultIcon" "" "$\"$EXEDIR\res.dll$\",10"
	WriteRegStr HKCR "Radasm.pas.3\shell\Open\Command" "" "$\"$EXEDIR\radasm.exe$\" $\"%1$\""
SectionEnd

Section ".prra"
	WriteRegStr HKCR ".prra" "" "Radasm.prra.3"
	WriteRegStr HKCR "Radasm.prra.3\DefaultIcon" "" "$\"$EXEDIR\res.dll$\",11"
	WriteRegStr HKCR "Radasm.prra.3\shell\Open\Command" "" "$\"$EXEDIR\radasm.exe$\" $\"%1$\""
SectionEnd

Section ".rc"
	WriteRegStr HKCR ".rc" "" "Radasm.rc.3"
	WriteRegStr HKCR "Radasm.rc.3\DefaultIcon" "" "$\"$EXEDIR\res.dll$\",12"
	WriteRegStr HKCR "Radasm.rc.3\shell\Open\Command" "" "$\"$EXEDIR\radasm.exe$\" $\"%1$\""
SectionEnd

Section
	SetOverwrite off
	SetOutPath "$EXEDIR"
	file res.dll 
	System::Call 'shell32.dll::SHChangeNotify(l, l, i, i) v (0x08000000, 0, 0, 0)'

	MessageBox MB_YESNO "Could you like create a shortcut of Radasm to Desktop ?" IDYES true IDNO false
	true:
		CreateShortCut "$DESKTOP\Radasm.lnk" "$EXEDIR\Radasm.exe"
	false:
SectionEnd